import { Injectable } from '@nestjs/common';
import { BaseUpdateStatusManager } from 'src/core/modules/domain/usecase/managers/base-update-status.manager';
import { {{pascalCase name}}Entity } from '../../entities/{{dashCase name}}.entity';
import { EventTopics, validateRelations } from 'src/core/strings/constants/interface.constants';
import { {{pascalCase name}}Model } from '../../../data/models/{{dashCase name}}.model';
import { {{pascalCase name}}ChangeStatusEvent } from '../../entities/event/{{dashCase name}}-change-status.event';

@Injectable()
export class Inactive{{pascalCase name}}Manager extends BaseUpdateStatusManager<{{pascalCase name}}Entity> {
  getResult(): string {
    return `Success inactive data ${this.result.name}`;
  }

  async validateProcess(): Promise<void> {
    return;
  }

  async beforeProcess(): Promise<void> {
    return;
  }

  async afterProcess(): Promise<void> {
    return;
  }

  get validateRelations(): validateRelations[] {
    return [];
  }

  get entityTarget(): any {
    return {{pascalCase name}}Model;
  }

  get eventTopics(): EventTopics[] {
    return [
      {
        topic: {{pascalCase name}}ChangeStatusEvent,
        data: this.data,
      },
    ];
  }
}
